<script>
    // import { dataStores } from '../stores/dataProductStore.js';

    export let plotElement;
    export let data;
    export let cadence;
    export let xScale;
    export let yScale;

    $: intervalWidth = xScale(cadence.cadence_sec*1e3)-xScale(0);
    $: barOffset = 0.5 * plotElement.plot_options.bar_padding * intervalWidth;
    $: barWidth = intervalWidth * (1-plotElement.plot_options.bar_padding);

    const fillColor = function(value) {
        var colorthresholds = plotElement.plot_options['fill_colors'];
        for (var i = 0; i < colorthresholds.length; i++) {
            var colorthreshold = colorthresholds[i];
            if (value < colorthreshold.threshold) {
                return colorthreshold.color;
            }
        }
        return '#888';
    }

    const strokeColor = function(value) {
        var colorthresholds = plotElement.plot_options['stroke_colors'];
        if (colorthresholds) {
          for (var i = 0; i < colorthresholds.length; i++) {
              var colorthreshold = colorthresholds[i];
              if (value < colorthreshold.threshold) {
                  return colorthreshold.color;
              }
          }
        }
        return '#000';
    }


    function kptext(kp)
        {
            let kpint = Math.trunc(kp)
            let kpdif = kp-kpint;
            if (kpdif < 0.1) {
                return kpint.toFixed(0);
            }
            if (kpdif > 0.2 && kpdif < 0.4) {
                return kpint.toFixed(0) + '+';
            }
            if (kpdif > 0.6 && kpdif < 0.9) {
                return (kpint+1).toFixed(0) + '-';
            }
        }

    function text_y(value, yScale) {
        if (value > 7) {
            return yScale(value) + 15;
        } else {
            return yScale(value) - 4;
        }
    }

    function text_fill(value) {
        if (value <= 7) {
            return "black";
        } else {
            return "white";
        }
    }
</script>

{#await data}
{:then datapoints}
{#if datapoints}
  {#each datapoints as d}
  <!-- Draw the bar -->
      <rect x={xScale(d.time)+barOffset}
            y={yScale(d[plotElement.parameter])}
            width={barWidth}
            height={yScale(0)-yScale(d[plotElement.parameter])}
            fill={fillColor(d[plotElement.parameter])}
            fill-opacity={plotElement.plot_options['fill-opacity']}
            stroke={strokeColor(d[plotElement.parameter])}
            stroke-width={plotElement.plot_options['stroke-width']}/>

  <!-- Optional text annotation of the value, if the bar is wide enough -->
      {#if intervalWidth > 35 && plotElement.plot_options['bar_text']}
          <text x={xScale(d.time) + 0.5*intervalWidth}
                y={text_y(d[plotElement.parameter], yScale)}
                class="bartext"
                text-anchor="middle"
                fill={text_fill(d[plotElement.parameter])}>
                {kptext(d[plotElement.parameter])}
          </text>
      {/if}
  {/each}
{/if}
{/await}
<style>
    text.bartext {
        font-size: 11px;
    }
</style>
